; Source created with Parsic Version 3.x

; at              : 16/08/02 14.40.11


; Project File    : c:\PROGRA~1\PARSIC\IMPIAN~1\ANTCASA.PIC

; Project Version : 1.0.54

; Created         : 16/08/02 11.47.00

; Last change     : 16/08/02 14.40.04

	PROCESSOR 12C508A

	INCLUDE P12C508A.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_ON & _WDT_ON & _INTRC_OSC & _MCLRE_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag
#DEFINE RETURN RETLW 0


; Variable

S0	= 7	; located in Bank 0
OS1_FD	= 8	; located in Bank 0
ZR1	= 9	; located in Bank 0
ZR1_FD	= 10	; located in Bank 0
MF1	= 11	; located in Bank 0
MF1_HI	= 12	; located in Bank 0
SYS_OLDTMR0	= 13	; located in Bank 0
MF2	= 14	; located in Bank 0
MF2_HI	= 15	; located in Bank 0
S1	= 16	; located in Bank 0
OS2_FD	= 17	; located in Bank 0
TR1	= 18	; located in Bank 0
TR1_HI	= 19	; located in Bank 0
ZR2	= 20	; located in Bank 0
ZR2_FD	= 21	; located in Bank 0
S2	= 22	; located in Bank 0
ZR3	= 23	; located in Bank 0
ZR3_FD	= 24	; located in Bank 0
OS3_FD	= 25	; located in Bank 0
OS4_FD	= 26	; located in Bank 0
S3	= 27	; located in Bank 0
RAM	= 28	; located in Bank 0

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF FSR
	MOVWF OSCCAL
	GOTO SYS_INIT

;****************************************
;Interrupt-Adress
;****************************************

SYS_INTERRUPT
	MOVFW SYS_OLDTMR0
	SUBWF TMR0,W
	BTFSS STATUS,CARRY
	GOTO SYS_INTERRUPT_START
	ADDWF SYS_OLDTMR0,F
	RETURN

SYS_INTERRUPT_START
	ADDWF SYS_OLDTMR0,F

	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF2,F
	GOTO SYS_INT_LABEL_1
	INCF MF2_HI,F

SYS_INT_LABEL_1
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_2
	INCF TR1_HI,F

SYS_INT_LABEL_2

EXITINT
	RETURN

;****************************************
; Subroutines
;****************************************


;****************************************
; Tables
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT


; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	MOVLW B'00000000'
	MOVWF GPIO

	MOVLW 79
	OPTION


; Richtung setzen

	MOVLW B'11001111'
	TRIS GPIO

; init vars


; Clear RAM

	MOVLW 7
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS STATUS,ZERO
	GOTO CR1


	CLRF TMR0

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS GPIO,0
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,0
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF S0,0
	BTFSC GPIO,0
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Zhler -> ZR1
;***************************************************

	BTFSS S0,1	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S0,0
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BSF GPIO,5
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF GPIO,5
LABEL_ZR1_SETOUT0_END

LABEL_ZR1_SETFD

	BTFSS S0,0
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; GND
;***************************************************

	BCF S0,1	; immer Low

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS GPIO,5
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS GPIO,1
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S0,2
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF S0,2
LABEL_LG1_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BTFSC S0,2	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S0,4
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BTFSC S0,4	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 15
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 66
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S0,4
LABEL_MF1_EXIT

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS GPIO,5
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BTFSC GPIO,2
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF S0,3
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF S0,3
LABEL_LG2_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Anzug-Verzgerung -> MF2
;***************************************************

	BTFSC S0,3	; Eingang auf High ?
	GOTO LABEL_MF2_CHKTIME	; Ja

; RESET

	CLRF MF2
	CLRF MF2_HI
	BCF S0,5
	GOTO LABEL_MF2_EXIT	; raus

LABEL_MF2_CHKTIME

	BTFSC S0,5	; Ausgang schon auf High ?
	GOTO LABEL_MF2_EXIT	; Ja

	MOVLW 15
	SUBWF MF2_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	MOVLW 66
	SUBWF MF2,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	BSF S0,5
LABEL_MF2_EXIT

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; ODER - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSC S0,4
	GOTO LABEL_LG3_TRUE
LABEL_LG3_2
	BTFSC S0,5
	GOTO LABEL_LG3_TRUE
LABEL_LG3_3
	BTFSC GPIO,3
	GOTO LABEL_LG3_TRUE

LABEL_LG3_FALSE
	BCF S0,6
	GOTO LABEL_LG3_ENDE
LABEL_LG3_TRUE
	BSF S0,6
LABEL_LG3_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; One Shot -> OS2
;***************************************************


	BTFSS S0,6
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S1,2
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF S1,2
	BTFSC S0,6
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S1,1
	GOTO LABEL_RS1_RESET
	BTFSS S1,3
	GOTO LABEL_RS1_ENDE
	BSF GPIO,4	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF GPIO,4	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSS GPIO,4
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BTFSS S0,7
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BSF S1,0
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF S1,0
LABEL_LG4_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 161
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,7
	GOTO LABEL_TR1_CLR
	BSF S0,7
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,7
LABEL_TR1_ENDE

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Zhler -> ZR2
;***************************************************

	BTFSS S1,1	; Reset ?
	GOTO LABEL_ZR2_COUNT
	CLRF ZR2
	GOTO LABEL_ZR2_SETOUT

LABEL_ZR2_COUNT

; Test auf positive Flanke

	BTFSC ZR2_FD,0
	GOTO LABEL_ZR2_SETFD
	BTFSS S1,0
	GOTO LABEL_ZR2_SETFD

	INCF ZR2,F

LABEL_ZR2_SETOUT

; Output Q2

	BTFSS ZR2,2
	GOTO LABEL_ZR2_SETOUT2
	BSF S2,2
	GOTO LABEL_ZR2_SETOUT2_END
LABEL_ZR2_SETOUT2
	BCF S2,2
LABEL_ZR2_SETOUT2_END

; Output Q3

	BTFSS ZR2,3
	GOTO LABEL_ZR2_SETOUT3
	BSF S2,3
	GOTO LABEL_ZR2_SETOUT3_END
LABEL_ZR2_SETOUT3
	BCF S2,3
LABEL_ZR2_SETOUT3_END

; Output Q4

	BTFSS ZR2,4
	GOTO LABEL_ZR2_SETOUT4
	BSF S2,4
	GOTO LABEL_ZR2_SETOUT4_END
LABEL_ZR2_SETOUT4
	BCF S2,4
LABEL_ZR2_SETOUT4_END

; Output Q5

	BTFSS ZR2,5
	GOTO LABEL_ZR2_SETOUT5
	BSF S2,5
	GOTO LABEL_ZR2_SETOUT5_END
LABEL_ZR2_SETOUT5
	BCF S2,5
LABEL_ZR2_SETOUT5_END

LABEL_ZR2_SETFD

	BTFSS S1,0
	GOTO LABEL_ZR2_SETFD2
	BSF ZR2_FD,0
	GOTO LABEL_ZR2_END
LABEL_ZR2_SETFD2
	BCF ZR2_FD,0
LABEL_ZR2_END

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; Zhler -> ZR3
;***************************************************

	BTFSS S3,0	; Reset ?
	GOTO LABEL_ZR3_COUNT
	CLRF ZR3
	GOTO LABEL_ZR3_SETOUT

LABEL_ZR3_COUNT

; Test auf positive Flanke

	BTFSC ZR3_FD,0
	GOTO LABEL_ZR3_SETFD
	BTFSS S1,5
	GOTO LABEL_ZR3_SETFD

	INCF ZR3,F

LABEL_ZR3_SETOUT

; Output Q4

	BTFSS ZR3,4
	GOTO LABEL_ZR3_SETOUT4
	BSF S1,6
	GOTO LABEL_ZR3_SETOUT4_END
LABEL_ZR3_SETOUT4
	BCF S1,6
LABEL_ZR3_SETOUT4_END

; Output Q5

	BTFSS ZR3,5
	GOTO LABEL_ZR3_SETOUT5
	BSF S1,7
	GOTO LABEL_ZR3_SETOUT5_END
LABEL_ZR3_SETOUT5
	BCF S1,7
LABEL_ZR3_SETOUT5_END

; Output Q6

	BTFSS ZR3,6
	GOTO LABEL_ZR3_SETOUT6
	BSF S2,0
	GOTO LABEL_ZR3_SETOUT6_END
LABEL_ZR3_SETOUT6
	BCF S2,0
LABEL_ZR3_SETOUT6_END

; Output Q7

	BTFSS ZR3,7
	GOTO LABEL_ZR3_SETOUT7
	BSF S2,1
	GOTO LABEL_ZR3_SETOUT7_END
LABEL_ZR3_SETOUT7
	BCF S2,1
LABEL_ZR3_SETOUT7_END

LABEL_ZR3_SETFD

	BTFSS S1,5
	GOTO LABEL_ZR3_SETFD2
	BSF ZR3_FD,0
	GOTO LABEL_ZR3_END
LABEL_ZR3_SETFD2
	BCF ZR3_FD,0
LABEL_ZR3_END

;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; ODER - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BTFSC S1,2
	GOTO LABEL_LG5_TRUE
LABEL_LG5_2
	BTFSC S1,4
	GOTO LABEL_LG5_TRUE

LABEL_LG5_FALSE
	BCF S1,3
	GOTO LABEL_LG5_ENDE
LABEL_LG5_TRUE
	BSF S1,3
LABEL_LG5_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG6
;***************************************************

LABEL_LG6_1
	BTFSS S0,6
	GOTO LABEL_LG6_FALSE
LABEL_LG6_2
	BTFSC GPIO,4
	GOTO LABEL_LG6_FALSE
LABEL_LG6_3
	BTFSS S0,7
	GOTO LABEL_LG6_FALSE

LABEL_LG6_TRUE
	BSF S1,5
	GOTO LABEL_LG6_ENDE
LABEL_LG6_FALSE
	BCF S1,5
LABEL_LG6_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; One Shot -> OS3
;***************************************************


	BTFSS S2,6
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S1,4
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF S1,4
	BTFSC S2,6
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG7
;***************************************************

LABEL_LG7_1
	BTFSS S1,6
	GOTO LABEL_LG7_FALSE
LABEL_LG7_2
	BTFSS S1,7
	GOTO LABEL_LG7_FALSE
LABEL_LG7_3
	BTFSS S2,0
	GOTO LABEL_LG7_FALSE
LABEL_LG7_4
	BTFSS S2,1
	GOTO LABEL_LG7_FALSE

LABEL_LG7_TRUE
	BSF S2,6
	GOTO LABEL_LG7_ENDE
LABEL_LG7_FALSE
	BCF S2,6
LABEL_LG7_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; UND - Gatter -> LG8
;***************************************************

LABEL_LG8_1
	BTFSS S2,2
	GOTO LABEL_LG8_FALSE
LABEL_LG8_2
	BTFSS S2,3
	GOTO LABEL_LG8_FALSE
LABEL_LG8_3
	BTFSS S2,4
	GOTO LABEL_LG8_FALSE
LABEL_LG8_4
	BTFSS S2,5
	GOTO LABEL_LG8_FALSE

LABEL_LG8_TRUE
	BSF S1,1
	GOTO LABEL_LG8_ENDE
LABEL_LG8_FALSE
	BCF S1,1
LABEL_LG8_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; One Shot -> OS4
;***************************************************


	BTFSC S0,6
	GOTO LABEL_OS4_1
	BTFSC OS4_FD,0
	GOTO LABEL_OS4_1
	BSF OS4_FD,0
	BSF S2,7
	GOTO LABEL_OS4_2
LABEL_OS4_1
	BCF S2,7
	BTFSS S0,6
	GOTO LABEL_OS4_2
	BCF OS4_FD,0
LABEL_OS4_2
;***************************************************

	CALL SYS_INTERRUPT

;***************************************************
; ODER - Gatter -> LG9
;***************************************************

LABEL_LG9_1
	BTFSC S1,4
	GOTO LABEL_LG9_TRUE
LABEL_LG9_2
	BTFSC S2,7
	GOTO LABEL_LG9_TRUE

LABEL_LG9_FALSE
	BCF S3,0
	GOTO LABEL_LG9_ENDE
LABEL_LG9_TRUE
	BSF S3,0
LABEL_LG9_ENDE
;***************************************************

	CALL SYS_INTERRUPT

;****************************************

	GOTO MAIN

	ORG 511

	MOVLW H'00'	; OSCCAL

	END

